'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _providers = require('./../providers');

var _util = require('./../util');

var _business = require('./../locales/int/business');

var BUSINESS = _interopRequireWildcard(_business);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var data = (0, _util.pull)('business.json', 'en');

var business = new _providers.Business();

describe('Test business provider', function () {

  it('should return company type for current locale', function () {
    expect(data.company.type.title).toContain(business.companyType());
    expect(data.company.type.abbr).toContain(business.companyType({ abbr: true }));
  });

  it('should return company name for current locale', function () {
    expect(data.company.name).toContain(business.company());
  });

  it('should return copyright for current locale', function () {
    expect(business.copyright()).toMatch(new RegExp(/© [A-z\W]+, (.*)/g));
  });

  it('should return currency in ISO format', function () {
    expect(BUSINESS.CURRENCIES).toContain(business.currencyISO());
  });

  it('should return random price', function () {
    var _business$price$split = business.price({ minimum: 1, maximum: 500 }).split(' '),
        _business$price$split2 = _slicedToArray(_business$price$split, 2),
        value = _business$price$split2[0],
        currency = _business$price$split2[1];

    expect(Number(value)).toBeGreaterThanOrEqual(1);
    expect(Number(value)).toBeLessThanOrEqual(500);
    expect(value).toMatch(/[0-9]+\.[0-9]{1,2}/g);
    expect(currency).toEqual('$');
  });
});