'use strict';

var _providers = require('../providers.js');

var clothingSizes = new _providers.ClothingSizes();

describe('Test clothingSizes provider', function () {
  it('should be in array', function () {
    expect(['L', 'M', 'S', 'XL', 'XS', 'XXL', 'XXS', 'XXXL']).toContain(clothingSizes.international());
  });

  it('should be in array', function () {
    var sizes = [];
    for (var i = 40; i < 62; i++) {
      if (i % 2 === 0) {
        sizes.push(i);
      }
    }
    expect(sizes).toContain(clothingSizes.european());
  });

  it('should be in range', function () {
    expect(clothingSizes.custom()).toBeGreaterThanOrEqual(40);
    expect(clothingSizes.custom()).toBeLessThanOrEqual(62);
  });
});