'use strict';

var _providers = require('./../providers');

var _util = require('./../util');

var _datetime = require('../locales/int/datetime');

var DATETIME = _interopRequireWildcard(_datetime);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var data = (0, _util.pull)('datetime.json', 'en');

var datetime = new _providers.DateTime();

describe('Test datetime provider', function () {

  it('should return random day of week for current locale', function () {
    expect(data.day.name).toContain(datetime.dayOfWeek());
    expect(data.day.abbr).toContain(datetime.dayOfWeek({ abbr: true }));
  });

  it('should return random month for current locale', function () {
    expect(data.month.name).toContain(datetime.month());
    expect(data.month.abbr).toContain(datetime.month({ abbr: true }));
  });

  it('should return random year', function () {
    expect(datetime.year()).toBeGreaterThanOrEqual(1990);
    expect(datetime.year()).toBeLessThanOrEqual(2050);
  });

  it('should return random century', function () {
    expect(DATETIME.ROMAN_NUMS).toContain(datetime.century());
  });

  it('should return random periodicity string', function () {
    expect(data.periodicity).toContain(datetime.periodicity());
  });
});