'use strict';

var _providers = require('../providers.js');

var _development = require('../locales/int/development.js');

var _util = require('./../util');

var development = new _providers.Development();
var data = (0, _util.pull)('science.json', 'en');

describe('Test development provider', function () {

  it('should be in array', function () {
    expect(_development.LICENSES).toContain(development.softwareLicense());
  });

  it('should be format {0}.{1}.{2}', function () {
    expect(development.version()).toMatch(/^[0-9]{1,2}.[0-9]{1,2}.[0-9]{1,2}$/);
  });

  it('should be in array', function () {
    expect(_development.NOSQL).toContain(development.database({ noSQL: true }));
    expect(_development.SQL).toContain(development.database({ noSQL: false }));
  });

  it('should be in array', function () {
    expect(_development.CONTAINER).toContain(development.container());
  });

  it('should be in array', function () {
    expect(['Git', 'Subversion']).toContain(development.versionControlSystem());
  });

  it('should be in array', function () {
    expect(_development.PROGRAMMING_LANGS).toContain(development.programmingLanguage());
  });

  it('should be in array', function () {
    expect(_development.BACKEND).toContain(development.backend());
  });

  it('should be in array', function () {
    expect(_development.FRONTEND).toContain(development.frontend());
  });

  it('should be in array', function () {
    expect(_development.OS).toContain(development.os());
  });

  it('should return link', function () {
    expect(development.stackOverflowQuestion()).toMatch(new RegExp(/^(http:\/\/stackoverflow.com\/questions\/)[0-9]{7}$/));
  });
});