'use strict';

var _providers = require('../providers.js');

var _file = require('../locales/int/file.js');

var file = new _providers.File();

describe('Test file provider', function () {

  it('should be in array', function () {
    expect(_file.EXTENSIONS['text']).toContain(file.extension({ fileType: 'text' }));
  });

  it('should be in array or throw error', function () {
    function showError() {
      file.mimeType({ type: "none" });
    }

    expect(_file.MIME_TYPES['application']).toContain(file.mimeType({ type: 'application' }));
    expect(showError).toThrowError('Unsupported mime type!');
  });
});