'use strict';

var _providers = require('../providers.js');

var _development = require('../locales/int/development.js');

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var path = new _providers.Path();

describe('Test path provider', function () {

  it('should be root string', function () {
    expect(path.root()).toMatch(/^(C\\\\\\\\)|(\/)/);
  });

  it('should be root string', function () {
    expect(path.user()).toMatch(/^(C\\\\\\\\Users\\\\\\\\)|(\/home\/)/);
  });

  it('should be root string', function () {
    expect(path.user().split(_path2.default.sep)).toHaveLength(3);
  });

  it('should be string length === 4 and be in array', function () {
    var result = path.usersFolder({ gender: 'female' }).split(_path2.default.sep);
    expect(result).toHaveLength(4);
    expect(_development.FOLDERS).toContain(result[3]);
  });

  it('should be string length === 4 and be in array', function () {
    var result = path.devDir({ gender: 'female' }).split(_path2.default.sep);
    expect(result).toHaveLength(5);
    expect(_development.PROGRAMMING_LANGS).toContain(result[4]);
  });

  it('should be string length === 4 and be in array', function () {
    var result = path.projectDir({ gender: 'female' }).split(_path2.default.sep);
    expect(result).toHaveLength(6);
    expect(_development.PROJECT_NAMES).toContain(result[5]);
  });
});